# This an autogenerated file
# Description for stochastic process at a sector.
# Generated with WindCurrent
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.windcurrent import WindCurrentBlueprint
from numpy import ndarray,asarray
from dmt.namedentity import NamedEntity

class WindCurrent(NamedEntity):
    """
    Description for stochastic process at a sector.
    Keyword arguments
    -----------------
    description : str
         (default "")
    name : str
         (default None)
    level : float
         measured level.(default 0.0)
    speed : ndarray
         the scatter data for speed.
    direction : ndarray
         the scatter data for direction.
    """

    def __init__(self , description="", name=None, level=0.0, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.name = name
        self.level = level
        self.speed = ndarray(2)
        self.direction = ndarray(2)
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return WindCurrentBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = str(value)

    @property
    def name(self) -> str:
        """"""
        return self.__name

    @name.setter
    def name(self, value: str):
        """Set name"""
        self.__name = str(value)

    @property
    def level(self) -> float:
        """measured level."""
        return self.__level

    @level.setter
    def level(self, value: float):
        """Set level"""
        self.__level = float(value)

    @property
    def speed(self) -> ndarray:
        """the scatter data for speed."""
        return self.__speed

    @speed.setter
    def speed(self, value: ndarray):
        """Set speed"""
        self.__speed = asarray(value)

    @property
    def direction(self) -> ndarray:
        """the scatter data for direction."""
        return self.__direction

    @direction.setter
    def direction(self, value: ndarray):
        """Set direction"""
        self.__direction = asarray(value)
