# This an autogenerated file
# JOINED EXTREME VALUES FOR DIFFERENT PROBABILITY.
# Generated with JointExtremeValues
from typing import Dict,Sequence,List
from dmt.blueprint import Blueprint
from .blueprints.jointextremevalues import JointExtremeValuesBlueprint
from numpy import ndarray,asarray
from dmt.entity import Entity

class JointExtremeValues(Entity):
    """
    JOINED EXTREME VALUES FOR DIFFERENT PROBABILITY.
    Keyword arguments
    -----------------
    description : str
         (default "")
    var1 : str
         first variable.(default None)
    var2 : str
         second variable.(default None)
    returnPeriods : ndarray
         return periods
    var1Extremes : ndarray
         extreme values for the variable 1
    var2Extremes : ndarray
         extreme values for the variable 2
    """

    def __init__(self , description="", var1=None, var2=None, **kwargs):
        super().__init__(**kwargs)
        self.description = description
        self.var1 = var1
        self.var2 = var2
        self.returnPeriods = ndarray(1)
        self.var1Extremes = ndarray(1)
        self.var2Extremes = ndarray(1)
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return JointExtremeValuesBlueprint()


    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = str(value)

    @property
    def var1(self) -> str:
        """first variable."""
        return self.__var1

    @var1.setter
    def var1(self, value: str):
        """Set var1"""
        self.__var1 = str(value)

    @property
    def var2(self) -> str:
        """second variable."""
        return self.__var2

    @var2.setter
    def var2(self, value: str):
        """Set var2"""
        self.__var2 = str(value)

    @property
    def returnPeriods(self) -> ndarray:
        """return periods"""
        return self.__returnPeriods

    @returnPeriods.setter
    def returnPeriods(self, value: ndarray):
        """Set returnPeriods"""
        self.__returnPeriods = asarray(value)

    @property
    def var1Extremes(self) -> ndarray:
        """extreme values for the variable 1"""
        return self.__var1Extremes

    @var1Extremes.setter
    def var1Extremes(self, value: ndarray):
        """Set var1Extremes"""
        self.__var1Extremes = asarray(value)

    @property
    def var2Extremes(self) -> ndarray:
        """extreme values for the variable 2"""
        return self.__var2Extremes

    @var2Extremes.setter
    def var2Extremes(self, value: ndarray):
        """Set var2Extremes"""
        self.__var2Extremes = asarray(value)
